## emacs23-non-dfsg 23.4+1

=== debian/changelog ===
emacs23-non-dfsg (23.4+1-1) unstable; urgency=low

  * Upgrade to upstream version 23.4.

  * Update debian/* for Emacs 23.4.

 -- Rob Browning <rlb@defaultvalue.org>  Tue, 20 Mar 2012 20:23:53 -0500
